# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['LoggerDefinitionVersionInitArgs', 'LoggerDefinitionVersion']

@pulumi.input_type
class LoggerDefinitionVersionInitArgs:
    def __init__(__self__, *,
                 logger_definition_id: pulumi.Input[str],
                 loggers: pulumi.Input[Sequence[pulumi.Input['LoggerDefinitionVersionLoggerArgs']]]):
        """
        The set of arguments for constructing a LoggerDefinitionVersion resource.
        """
        pulumi.set(__self__, "logger_definition_id", logger_definition_id)
        pulumi.set(__self__, "loggers", loggers)

    @property
    @pulumi.getter(name="loggerDefinitionId")
    def logger_definition_id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "logger_definition_id")

    @logger_definition_id.setter
    def logger_definition_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "logger_definition_id", value)

    @property
    @pulumi.getter
    def loggers(self) -> pulumi.Input[Sequence[pulumi.Input['LoggerDefinitionVersionLoggerArgs']]]:
        return pulumi.get(self, "loggers")

    @loggers.setter
    def loggers(self, value: pulumi.Input[Sequence[pulumi.Input['LoggerDefinitionVersionLoggerArgs']]]):
        pulumi.set(self, "loggers", value)


warnings.warn("""LoggerDefinitionVersion is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""", DeprecationWarning)


class LoggerDefinitionVersion(pulumi.CustomResource):
    warnings.warn("""LoggerDefinitionVersion is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""", DeprecationWarning)

    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 logger_definition_id: Optional[pulumi.Input[str]] = None,
                 loggers: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['LoggerDefinitionVersionLoggerArgs']]]]] = None,
                 __props__=None):
        """
        Resource Type definition for AWS::Greengrass::LoggerDefinitionVersion

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: LoggerDefinitionVersionInitArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource Type definition for AWS::Greengrass::LoggerDefinitionVersion

        :param str resource_name: The name of the resource.
        :param LoggerDefinitionVersionInitArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(LoggerDefinitionVersionInitArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 logger_definition_id: Optional[pulumi.Input[str]] = None,
                 loggers: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['LoggerDefinitionVersionLoggerArgs']]]]] = None,
                 __props__=None):
        pulumi.log.warn("""LoggerDefinitionVersion is deprecated: LoggerDefinitionVersion is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""")
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = LoggerDefinitionVersionInitArgs.__new__(LoggerDefinitionVersionInitArgs)

            if logger_definition_id is None and not opts.urn:
                raise TypeError("Missing required property 'logger_definition_id'")
            __props__.__dict__["logger_definition_id"] = logger_definition_id
            if loggers is None and not opts.urn:
                raise TypeError("Missing required property 'loggers'")
            __props__.__dict__["loggers"] = loggers
            __props__.__dict__["aws_id"] = None
        replace_on_changes = pulumi.ResourceOptions(replace_on_changes=["logger_definition_id", "loggers[*]"])
        opts = pulumi.ResourceOptions.merge(opts, replace_on_changes)
        super(LoggerDefinitionVersion, __self__).__init__(
            'aws-native:greengrass:LoggerDefinitionVersion',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'LoggerDefinitionVersion':
        """
        Get an existing LoggerDefinitionVersion resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = LoggerDefinitionVersionInitArgs.__new__(LoggerDefinitionVersionInitArgs)

        __props__.__dict__["aws_id"] = None
        __props__.__dict__["logger_definition_id"] = None
        __props__.__dict__["loggers"] = None
        return LoggerDefinitionVersion(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="awsId")
    def aws_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "aws_id")

    @property
    @pulumi.getter(name="loggerDefinitionId")
    def logger_definition_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "logger_definition_id")

    @property
    @pulumi.getter
    def loggers(self) -> pulumi.Output[Sequence['outputs.LoggerDefinitionVersionLogger']]:
        return pulumi.get(self, "loggers")

