# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['PlacementArgs', 'Placement']

@pulumi.input_type
class PlacementArgs:
    def __init__(__self__, *,
                 project_name: pulumi.Input[str],
                 associated_devices: Optional[Any] = None,
                 attributes: Optional[Any] = None,
                 placement_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Placement resource.
        :param Any associated_devices: Search the [CloudFormation User Guide](https://docs.aws.amazon.com/cloudformation/) for `AWS::IoT1Click::Placement` for more information about the expected schema for this property.
        :param Any attributes: Search the [CloudFormation User Guide](https://docs.aws.amazon.com/cloudformation/) for `AWS::IoT1Click::Placement` for more information about the expected schema for this property.
        """
        pulumi.set(__self__, "project_name", project_name)
        if associated_devices is not None:
            pulumi.set(__self__, "associated_devices", associated_devices)
        if attributes is not None:
            pulumi.set(__self__, "attributes", attributes)
        if placement_name is not None:
            pulumi.set(__self__, "placement_name", placement_name)

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> pulumi.Input[str]:
        return pulumi.get(self, "project_name")

    @project_name.setter
    def project_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "project_name", value)

    @property
    @pulumi.getter(name="associatedDevices")
    def associated_devices(self) -> Optional[Any]:
        """
        Search the [CloudFormation User Guide](https://docs.aws.amazon.com/cloudformation/) for `AWS::IoT1Click::Placement` for more information about the expected schema for this property.
        """
        return pulumi.get(self, "associated_devices")

    @associated_devices.setter
    def associated_devices(self, value: Optional[Any]):
        pulumi.set(self, "associated_devices", value)

    @property
    @pulumi.getter
    def attributes(self) -> Optional[Any]:
        """
        Search the [CloudFormation User Guide](https://docs.aws.amazon.com/cloudformation/) for `AWS::IoT1Click::Placement` for more information about the expected schema for this property.
        """
        return pulumi.get(self, "attributes")

    @attributes.setter
    def attributes(self, value: Optional[Any]):
        pulumi.set(self, "attributes", value)

    @property
    @pulumi.getter(name="placementName")
    def placement_name(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "placement_name")

    @placement_name.setter
    def placement_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "placement_name", value)


warnings.warn("""Placement is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""", DeprecationWarning)


class Placement(pulumi.CustomResource):
    warnings.warn("""Placement is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""", DeprecationWarning)

    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 associated_devices: Optional[Any] = None,
                 attributes: Optional[Any] = None,
                 placement_name: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Resource Type definition for AWS::IoT1Click::Placement

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param Any associated_devices: Search the [CloudFormation User Guide](https://docs.aws.amazon.com/cloudformation/) for `AWS::IoT1Click::Placement` for more information about the expected schema for this property.
        :param Any attributes: Search the [CloudFormation User Guide](https://docs.aws.amazon.com/cloudformation/) for `AWS::IoT1Click::Placement` for more information about the expected schema for this property.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PlacementArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource Type definition for AWS::IoT1Click::Placement

        :param str resource_name: The name of the resource.
        :param PlacementArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PlacementArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 associated_devices: Optional[Any] = None,
                 attributes: Optional[Any] = None,
                 placement_name: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        pulumi.log.warn("""Placement is deprecated: Placement is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""")
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PlacementArgs.__new__(PlacementArgs)

            __props__.__dict__["associated_devices"] = associated_devices
            __props__.__dict__["attributes"] = attributes
            __props__.__dict__["placement_name"] = placement_name
            if project_name is None and not opts.urn:
                raise TypeError("Missing required property 'project_name'")
            __props__.__dict__["project_name"] = project_name
            __props__.__dict__["aws_id"] = None
        replace_on_changes = pulumi.ResourceOptions(replace_on_changes=["associated_devices", "placement_name", "project_name"])
        opts = pulumi.ResourceOptions.merge(opts, replace_on_changes)
        super(Placement, __self__).__init__(
            'aws-native:iot1click:Placement',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Placement':
        """
        Get an existing Placement resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = PlacementArgs.__new__(PlacementArgs)

        __props__.__dict__["associated_devices"] = None
        __props__.__dict__["attributes"] = None
        __props__.__dict__["aws_id"] = None
        __props__.__dict__["placement_name"] = None
        __props__.__dict__["project_name"] = None
        return Placement(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="associatedDevices")
    def associated_devices(self) -> pulumi.Output[Optional[Any]]:
        """
        Search the [CloudFormation User Guide](https://docs.aws.amazon.com/cloudformation/) for `AWS::IoT1Click::Placement` for more information about the expected schema for this property.
        """
        return pulumi.get(self, "associated_devices")

    @property
    @pulumi.getter
    def attributes(self) -> pulumi.Output[Optional[Any]]:
        """
        Search the [CloudFormation User Guide](https://docs.aws.amazon.com/cloudformation/) for `AWS::IoT1Click::Placement` for more information about the expected schema for this property.
        """
        return pulumi.get(self, "attributes")

    @property
    @pulumi.getter(name="awsId")
    def aws_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "aws_id")

    @property
    @pulumi.getter(name="placementName")
    def placement_name(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "placement_name")

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> pulumi.Output[str]:
        return pulumi.get(self, "project_name")

