# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from .. import _inputs as _root_inputs
from .. import outputs as _root_outputs
from ._inputs import *

__all__ = ['DbSecurityGroupArgs', 'DbSecurityGroup']

@pulumi.input_type
class DbSecurityGroupArgs:
    def __init__(__self__, *,
                 db_security_group_ingress: pulumi.Input[Sequence[pulumi.Input['DbSecurityGroupIngressArgs']]],
                 group_description: pulumi.Input[str],
                 ec2_vpc_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]] = None):
        """
        The set of arguments for constructing a DbSecurityGroup resource.
        """
        pulumi.set(__self__, "db_security_group_ingress", db_security_group_ingress)
        pulumi.set(__self__, "group_description", group_description)
        if ec2_vpc_id is not None:
            pulumi.set(__self__, "ec2_vpc_id", ec2_vpc_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="dbSecurityGroupIngress")
    def db_security_group_ingress(self) -> pulumi.Input[Sequence[pulumi.Input['DbSecurityGroupIngressArgs']]]:
        return pulumi.get(self, "db_security_group_ingress")

    @db_security_group_ingress.setter
    def db_security_group_ingress(self, value: pulumi.Input[Sequence[pulumi.Input['DbSecurityGroupIngressArgs']]]):
        pulumi.set(self, "db_security_group_ingress", value)

    @property
    @pulumi.getter(name="groupDescription")
    def group_description(self) -> pulumi.Input[str]:
        return pulumi.get(self, "group_description")

    @group_description.setter
    def group_description(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_description", value)

    @property
    @pulumi.getter(name="ec2VpcId")
    def ec2_vpc_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ec2_vpc_id")

    @ec2_vpc_id.setter
    def ec2_vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ec2_vpc_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]]):
        pulumi.set(self, "tags", value)


warnings.warn("""DbSecurityGroup is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""", DeprecationWarning)


class DbSecurityGroup(pulumi.CustomResource):
    warnings.warn("""DbSecurityGroup is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""", DeprecationWarning)

    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_security_group_ingress: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DbSecurityGroupIngressArgs']]]]] = None,
                 ec2_vpc_id: Optional[pulumi.Input[str]] = None,
                 group_description: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['_root_inputs.TagArgs']]]]] = None,
                 __props__=None):
        """
        Resource Type definition for AWS::RDS::DBSecurityGroup

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DbSecurityGroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource Type definition for AWS::RDS::DBSecurityGroup

        :param str resource_name: The name of the resource.
        :param DbSecurityGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DbSecurityGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_security_group_ingress: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DbSecurityGroupIngressArgs']]]]] = None,
                 ec2_vpc_id: Optional[pulumi.Input[str]] = None,
                 group_description: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['_root_inputs.TagArgs']]]]] = None,
                 __props__=None):
        pulumi.log.warn("""DbSecurityGroup is deprecated: DbSecurityGroup is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""")
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DbSecurityGroupArgs.__new__(DbSecurityGroupArgs)

            if db_security_group_ingress is None and not opts.urn:
                raise TypeError("Missing required property 'db_security_group_ingress'")
            __props__.__dict__["db_security_group_ingress"] = db_security_group_ingress
            __props__.__dict__["ec2_vpc_id"] = ec2_vpc_id
            if group_description is None and not opts.urn:
                raise TypeError("Missing required property 'group_description'")
            __props__.__dict__["group_description"] = group_description
            __props__.__dict__["tags"] = tags
            __props__.__dict__["aws_id"] = None
        replace_on_changes = pulumi.ResourceOptions(replace_on_changes=["ec2_vpc_id", "group_description"])
        opts = pulumi.ResourceOptions.merge(opts, replace_on_changes)
        super(DbSecurityGroup, __self__).__init__(
            'aws-native:rds:DbSecurityGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DbSecurityGroup':
        """
        Get an existing DbSecurityGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DbSecurityGroupArgs.__new__(DbSecurityGroupArgs)

        __props__.__dict__["aws_id"] = None
        __props__.__dict__["db_security_group_ingress"] = None
        __props__.__dict__["ec2_vpc_id"] = None
        __props__.__dict__["group_description"] = None
        __props__.__dict__["tags"] = None
        return DbSecurityGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="awsId")
    def aws_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "aws_id")

    @property
    @pulumi.getter(name="dbSecurityGroupIngress")
    def db_security_group_ingress(self) -> pulumi.Output[Sequence['outputs.DbSecurityGroupIngress']]:
        return pulumi.get(self, "db_security_group_ingress")

    @property
    @pulumi.getter(name="ec2VpcId")
    def ec2_vpc_id(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "ec2_vpc_id")

    @property
    @pulumi.getter(name="groupDescription")
    def group_description(self) -> pulumi.Output[str]:
        return pulumi.get(self, "group_description")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence['_root_outputs.Tag']]]:
        return pulumi.get(self, "tags")

